暴力状压 [Usaco2007 Open]Fliptile 翻格子游戏

 

问题 B: [Usaco2007 Open]Fliptile 翻格子游戏

时间限制: 5 Sec  内存限制: 128 MB

题目描述

Farmer John knows that an intellectually satisfied cow is a happy cow who will give more milk. He has arranged a brainy activity for cows in which they manipulate an M x N grid (1 <= M <= 15; 1 <= N <= 15) of square tiles, each of which is colored black on one side and white on the other side. As one would guess, when a single white tile is flipped, it changes to black; when a single black tile is flipped, it changes to white. The cows are rewarded when they flip the tiles so that each tile has the white side face up. However, the cows have rather large hooves and when they try to flip a certain tile, they also flip all the adjacent tiles (tiles that share a full edge with the flipped tile). Since the flips are tiring, the cows want to minimize the number of flips they have to make. Help the cows determine the minimum number of flips required, and the locations to flip to achieve that minimum. If there are multiple ways to achieve the task with the minimum amount of flips, return the one with the least lexicographical ordering in the output when considered as a string. If the task is impossible, print one line with the word "IMPOSSIBLE".

 约翰知道,那些高智力又快乐的奶牛产奶量特别高.所以他做了一个翻瓦片的益智游戏来娱乐奶牛.在一个M×N(1≤M,N≤15)的骨架上,每一个格子里都有一个可以翻转的瓦片.瓦片的一面是黑色的,而另一面是白色的.对一个瓦片进行翻转,可以使黑变白,也可以使白变黑.然而,奶牛们的蹄子是如此的巨大而且笨拙,所以她们翻转一个瓦片的时候,与之有公共边的相邻瓦片也都被翻转了.那么,这些奶牛们最少需要多少次翻转,使所有的瓦片都变成白面向上呢?如杲可以做到,输出字典序最小的结果(将结果当成字符串处理).如果不能做到,输出“IMPOSSIBLE”.

输入

* Line 1: Two space-separated integers: M and N

* Lines 2..M+1: Line i+1 describes the colors (left to right) of row i of the grid with N space-separated integers which are 1 for black and 0 for white

    第1行输入M和N,之后M行N列,输入游戏开始时的瓦片状态.0表示白面向上,1表示黑面向上.

输出

* Lines 1..M: Each line contains N space-separated integers, each specifying how many times to flip that particular location.

    输出M行,每行N个用空格隔开的整数,表示对应的格子进行了多少次翻转.

样例输入

4 4
1 0 0 1
0 1 1 0
0 1 1 0
1 0 0 1


样例输出

0 0 0 0
1 0 0 1
1 0 0 1
0 0 0 0

OUTPUT DETAILS:

After flipping at row 2 column 1, the board will look like:
0 0 0 1
1 0 1 0
1 1 1 0
1 0 0 1

After flipping at row 2 column 4, the board will look like:
0 0 0 0
1 0 0 1
1 1 1 1
1 0 0 1

After flipping at row 3 column 1, the board will look like:
0 0 0 0
0 0 0 1
0 0 1 1
0 0 0 1

After flipping at row 3 column 4, the board will look like:
0 0 0 0
0 0 0 0
0 0 0 0
0 0 0 0

Another solution might be:
0 1 1 0
0 0 0 0
0 0 0 0
0 1 1 0
but this solution is lexicographically higher than the solution above.

提示

    其实和状压并没有太大的关系,只是用来枚举第一行状态。
     因为一个点翻两次又变回原来的颜色,所以要么不翻,要么只翻一次,而且这个点的状态至于他周围四个点及自己翻不翻还有自己初始状态有关。
     如果加和为偶数,那么翻到了白色,
     枚举第一行的状态,那么他最后的状态只与下一行有关,又因为这一行必须全是白色,所以可以一直推出最后一行的状态。最后判断最后一行能否满足全为白,满足则此状态为合法,
     
#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<cstring>
#include<algorithm>
using namespace std;
int n,m,a[20][20],xp[16],f[20][20],ans=10000;
int main()
{
    //freopen("fliptile.in","r",stdin);
//	freopen("fliptile.out","w",stdout);
	cin>>m>>n;
	for(int i=1;i<=m;i++)
	   for(int j=1;j<=n;j++)
	   	   scanf("%d",&a[i][j]),f[i][j]=2;
     xp[0]=1;
     for(int i=1;i<=n;i++)
        xp[i]=xp[i-1]*2;
	int d[20],b[20][20],cnt=0;
	for(int i=0;i<xp[n];i++)
	{
	    cnt=0;
		for(int j=1;j<=n;j++)
		{
			d[j]=a[1][j];
			if(i&xp[j-1])
			   b[1][j]=1,cnt++;
			else
			   b[1][j]=0;
			if(i&xp[j-1])
		       d[j]+=1;
    		if(j!=1&&(i&xp[j-2]))
    		   d[j]+=1;
    		if(j!=n&&(i&xp[j]))
    		   d[j]+=1;
		}
		for(int j=2;j<=m;j++)
        {
        	for(int k=1;k<=n;k++)
        	  if(d[k]%2)
        	  {
        	     d[k]=1;
        	     b[j][k]=1;
        	     cnt++;
			 }
			 else
			 {
			     d[k]=0;b[j][k]=0;
			 }
			for(int k=1;k<=n;k++)
			{
				d[k]+=a[j][k];
				if(k!=1)d[k]+=b[j][k-1];
				if(k!=n)d[k]+=b[j][k+1];
				d[k]+=b[j-1][k];
			}
		}
		int p=0;
		for(int j=1;j<=n;j++)
		   if(d[j]%2){p=1;break;}
		if((!p)&&ans>cnt)
		{
	   	    for(int w=1;w<=m;w++)
	   	    {
	   	    	int o=0;
	   	        for(int j=1;j<=n;j++)
	   	          if(f[w][j]>b[w][j])
	   	          {
	   	          	   ans=cnt;
	   	          	   for(int k=1;k<=m;k++)
	   	          	      for(int h=1;h<=n;h++)
	   	          	         f[k][h]=b[k][h];
	   	          	    o=1;break;
				  }
	   	          else
	   	          {
	   	          	   if(f[w][j]<b[w][j]){o=1;break;}
				  }
				  if(o==1)break;
			}
		}
	}
	if(ans==10000)
	{printf("IMPOSSIBLE
");return 0;}
	for(int i=1;i<=m;i++)
	{
		for(int j=1;j<=n;j++)
		  cout<<f[i][j]<<" ";
		cout<<endl;
	}
}

原文地址:https://www.cnblogs.com/QTY2001/p/7632753.html